#immediately run this on players who join the world
execute as @a[scores={join=1..}] run function parkour_grand_prix:join

#in case multiple players are in edit mode at the same time...
#only ONE of them will carry out important node summoning commands
tag @a[limit=1,sort=random] add executor

#players in creative mode get admin controls
execute as @a[gamemode=creative,tag=!restricted] at @s run function parkour_grand_prix:admin

#potion effects
function parkour_grand_prix:effects/passive
function parkour_grand_prix:effects/special_blocks

#GAME LOGIC
#playerState=0 means in-menu
#playerState=1 means in-game
#playerState=2 means using editor tools (admin)
execute as @a[scores={playerState=1}] at @s run function parkour_grand_prix:game_logic/1/gl1_main
execute as @a[gamemode=creative,scores={playerState=2}] at @s run function parkour_grand_prix:game_logic/2/gl2_main

#node functions, globalized for better optimization
#nodes only do stuff if they've found a player in their hitbox
#execute as @e[tag=checkpoint,tag=!checkAnyY,tag=foundplayer] at @s run function parkour_grand_prix:game_logic/1/index_checkpoint
#execute as @e[tag=checkpoint,tag=checkAnyY,tag=foundplayer] at @s run function parkour_grand_prix:game_logic/1/index_checkpoint_any_y
execute as @e[tag=checkpoint,tag=!checkAnyY,tag=foundplayer] at @s run function parkour_grand_prix:game_logic/1/checkpoint_operate
execute as @e[tag=checkpoint,tag=checkAnyY,tag=foundplayer] at @s run function parkour_grand_prix:game_logic/1/checkpoint_operate_any_y
execute as @e[tag=finishline,tag=!finAnyY,tag=foundplayer] at @s run function parkour_grand_prix:game_logic/1/finishline_operate
execute as @e[tag=finishline,tag=finAnyY,tag=foundplayer] at @s run function parkour_grand_prix:game_logic/1/finishline_operate_any_y

#checkpoint stuff
scoreboard players remove @a[scores={checkDelay=1..}] checkDelay 1
execute as @a[tag=checkIncrement] at @s run function parkour_grand_prix:game_logic/1/increment_checkpoint
execute as @a[tag=finishLap,tag=!practice] at @s run function parkour_grand_prix:game_logic/1/finish_lap
execute as @a[tag=finishLap,tag=practice] at @s run function parkour_grand_prix:game_logic/1/finish_lap_practice

#universal hotbar display function
execute as @a run function parkour_grand_prix:hotbar_display

#scoreboard cleanup
tag @e[tag=foundplayer] remove foundplayer
tag @a[tag=selecting] remove selecting
tag @a[tag=executor] remove executor
tag @a[tag=finWarn,scores={playerState=1}] remove finWarn
tag @a[tag=finWrongWay,scores={playerState=1}] remove finWrongWay
tag @a[tag=checkWarn,scores={playerState=1}] remove checkWarn
tag @a[tag=checkWrongWay,scores={playerState=1}] remove checkWrongWay
scoreboard players set @a[gamemode=adventure,scores={playerState=2}] playerState 1

#nodes are visualized if a player is in editor mode
execute unless entity @a[scores={playerState=2}] if entity @e[tag=node,tag=showing] as @e[tag=node,tag=showing] run function parkour_grand_prix:node_hide
execute if entity @a[scores={playerState=2}] if entity @e[tag=node,tag=!showing] as @e[tag=node,tag=!showing] run function parkour_grand_prix:node_show

#all items with a lifespawn run this function
execute as @e[scores={lifespan=..99999}] run function parkour_grand_prix:entity_lifespan
#kill all unwanted item drops
kill @e[type=item,tag=!stay]
kill @e[type=experience_orb,tag=!stay]